% Pitch estimation

clear
close all
clc

path('..\..\voicebox', path)

%% Read data containing WAV and EGG signal (from ARCTIC)
%  (first channel contains sound, second channel contains EGG)
[data fs] = wavread('bdl_arctic_a0013.wav');
x   = resample(data(:,1), 1,2);
egg = resample(data(:,2), 1,2);
fs  = fs/2;
% soundsc(x,fs);

%% Compute pitch track with voicebox
[fx,tt]=fxrapt(x,fs); 

% Remove spurious pitch values
fx(find(fx>mean(fx)+3*std(fx))) = 0;

%% Plot results
figure
subplot(211)
plot([tt(:,1) tt(:,1)], [min(x) max(x)], 'g')
hold on
plot([tt(:,2) tt(:,2)], [min(x) max(x)], 'r')
plot(x); axis tight
xlabel('time'); ylabel('pitch boundaries'); axis tight

subplot(212)
plot(fx, '.') 
xlabel('frame'); ylabel('F0'); axis tight