function [voiced rms zc] = vuv(x,fs,wlen,wshft)

% Very inneficient way of estimating zero crossings
n = 0;
f = 1;
while n+wlen<=length(x)
  s = x(n+(1:wlen));
  rms(f) = sqrt(sumsqr(s));
  zc(f)  = sum(abs(sign(s)-sign([0; s(1:end-1)])));
  n = n+wshft;
  f = f+1;
end

% Normalize both estimates (so we can use a normalized threshold)
rms = (rms-min(rms))/(max(rms)-min(rms));
zc  = (zc -min(zc)) /(max( zc)-min( zc));

% Combine both into a voicing decision
% voiced1 = (rms>0.1).*(zc<0.1);
voiced = double(rms>zc);

% Resample the voiced detector to match fs
voiced_fs = resample(voiced, length(x), length(voiced));
